## autopkgtest 2.3.7

=== debian/changelog ===
autopkgtest (2.3.7) unstable; urgency=low

  * tests/adt-run: Factorize a base test class with common functionality.
  * lib/VirtSubproc.py, downtmp_mktemp(): Create temporary directory in the
    target (which isn't the host for anything but the null runner), to fix the
    schroot/chroot runners for directories.
  * Only show stdout/stderr in realtime if tests run in the same file system
    as the host, as otherwise we cannot create/use a named pipe. If not, fall
    back to the old way of just showing the complete stdout/stderr after the
    tests finished. (LP: #1235189)
  * Add some test cases for adt-virt-chroot.
  * Add new --timeout-copy option to make copy timeout configurable. Pass that
    down to adt-virt-* via the environment ($ADT_VIRT_COPY_TIMEOUT).
    (LP: #1200693)
  * Fix tests to also work with Python 3.1.
  * tests/testpkg: Go back to compat level 7 so that this also works on older
    Debian/Ubuntu releases.

 -- Martin Pitt <mpitt@debian.org>  Tue, 08 Oct 2013 18:55:33 +0200

autopkgtest (2.3.6) unstable; urgency=low

  * Always kill the tee children after a test finishes, to avoid race
    condition when they get stuck in a read() call which doesn't return with
    "no data".
  * Fix pyflakes failure on older Debian/Ubuntu releases.
  * Fix PEP-8 errors.

 -- Martin Pitt <mpitt@debian.org>  Thu, 26 Sep 2013 13:12:11 +0200

autopkgtest (2.3.5) unstable; urgency=low

  * Don't show source_rules_command() "set -x" trace unless running with -d.
  * Kill the tee child process if the testbed bombs out (e. g. due to a
    timeout), to avoid hanging eternally. Add test case for --timeout-test
    handling.
  * Add test case for --summary option.

 -- Martin Pitt <mpitt@debian.org>  Wed, 25 Sep 2013 08:51:21 +0200

autopkgtest (2.3.4) unstable; urgency=low

  * Add tests/testpkg/: Simple source package for testing autopkgtest.
  * Add tests/adt-run: Automatic regression tests for adt-run, covering/using
    the null runner.
  * Add debian/tests: autopkgtest for autopkgtest, using tests/adt-run.
  * Make topmost temporary directory group/world-readable and make $ADTTMP
    have appropriate 1777 permissions so that users other than root can
    actually use it. (Closes: #722458)
  * Don't clip first stderr line to 35 characters in summary. (Side issue in
    #722457)
  * Don't show shell tracing of script that creates the temporary directories.
  * Move unimportant messages to debug level 1, to not clutter up default
    output so much.
  * Drop unnecessary "trace: " from adt-run debug/progress lines.
  * Show stdout/err of the running tests in realtime, which is much nicer for
    watching. Don't split that realtime output, so that stderr messages appear
    in the right context. Show separate stderr if and only if the allow-stderr
    restriction is not set and there is stderr output. (Closes: #722457)
  * For tests with "build-needed", actually run the tests in the built
    directory, not in the original unbuilt tree. (Closes: #711209)
  * Fix various unknown and unused symbols throughout the source, spotted by
    pyflakes.
  * Add tests/pyflakes: Run pyflakes over source and test code.
  * Add tests/pep8: Run pep8 over source and test code.
  * Support empty "Depends:" test control field, installing no dependencies in
    that case.
  * README.package-tests: Point out that you can use upper-case test names as
    well. Update test_tree_tmp_dir() test to use these, to ensure it stays
    working. (Closes: #711844)
  * Some code cleanups:
    - Don't rename modules on import.
    - Format to be PEP-8 compliant.
    - Rename first argument of methods to "self", as that's the wide
      convention, gets rid of some single-letter variable names, and makes it
      a bit easier to see which variables refer to foreign objects.
  * Run tests/pep8 and tests/pyflakes during package build.

 -- Martin Pitt <mpitt@debian.org>  Mon, 23 Sep 2013 14:44:13 +0200

autopkgtest (2.3.3) unstable; urgency=low

  * runner/adt-run: Drop "errors" keyword from decode() call to fix
    compatibility with earlier Python versions. Thanks Christoph Berg.
  * adt-run: Fail tests if they exit with nonzero if "allow-stderr"
    restriction is set. Thanks Robie Basak! (LP: #1210503)

 -- Martin Pitt <mpitt@debian.org>  Mon, 09 Sep 2013 15:49:52 -0400

autopkgtest (2.3.2) unstable; urgency=low

  * runner/adt-run: Fix "allow-stderr" restrictions to still report success,
    so that this gets into the summary.log.

 -- Martin Pitt <mpitt@debian.org>  Fri, 26 Jul 2013 12:41:07 +0200

autopkgtest (2.3.1) unstable; urgency=low

  * adt-run: Support older python-debian versions whose module was still
    called "debian_bundle". (Closes: #717191)
  * runner/adt-run: Correctly re-raise exception on some register failure
    errors. Thanks Robie Basak!
  * runner/adt-run: Short-circuit publishing if there are no registered built
    binaries. This is the step that takes by far the longest time for short
    tests, and thus speeds up test running significantly.
  * runner/adt-run: Set DEBIAN_FRONTEND=noninteractive for installing build or
    test dependencies, too. Thanks Robie Basak! (LP: #1204989)

 -- Martin Pitt <mpitt@debian.org>  Fri, 26 Jul 2013 08:02:35 +0200

autopkgtest (2.3) unstable; urgency=low

  * runner/adt-run.1: Fix bad "affect modify" wording. (LP: #1199500)
  * Drop hosts/chinstrap. We haven't actually used this in many years, it has
    been replaced with https://launchpad.net/auto-package-testing, Jenkins,
    and blocking migration to release until tests pass. (LP: #381210)
  * Promote apt-utils from Recommends to Depends:, to avoid test failures due
    to not finding apt-ftparchive. (LP: #1065874)
  * Promote pbuilder from Recommends: to Depends:, as we always call
    pbuilder-satisfydepends-classic. (LP: #1065874)
  * runner/adt-run: Stop explicitly checking for $HOME (with broken error
    message) when giving --gnupg-home, use os.path.expanduser() instead.
    (LP: #1065873)


=== debian/control ===
Source: autopkgtest
Maintainer: Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>
Uploaders: Ian Jackson <ijackson@chiark.greenend.org.uk>, Martin Pitt <mpitt@debian.org>
Section: devel
Priority: optional
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 8),
 pyflakes,
 pep8
Vcs-Git: git://git.debian.org/git/autopkgtest/autopkgtest.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=autopkgtest/autopkgtest.git
XS-Testsuite: autopkgtest

Package: autopkgtest
Architecture: all
Depends: python (>= 2.6),
 debhelper,
 python-debian,
 apt-utils,
 pbuilder,
 ${misc:Depends}
Conflicts: autodebtest (<< 0.5.3)
Replaces: autodebtest (<< 0.5.3)
Suggests: autopkgtest-xenlvm, curl
Description: automatic as-installed testing for Debian packages
 autopkgtest runs tests on binary packages.  The tests are run on the
 package as installed on a testbed system (which may be found via a
 virtualisation or containment system).  The tests are expected to be
 supplied in the corresponding Debian source package.
 .
 See adt-run(1) and /usr/share/doc/autopkgtest.
 Most modes of use require apt-ftparchive from the apt-utils package.
 Use of adt-virt-xenlvm requires the autopkgtest-xenlvm package too;
 Use of the pre-cooked adt-testreport-onepackage script requires curl.

Package: autopkgtest-xenlvm
Architecture: all
Depends: libadns1-bin, chiark-utils-bin, iproute, dmsetup, ${misc:Depends}
Recommends: lvm2, debootstrap
Suggests: autopkgtest
Description: Xen/LVM2 based testbed snapshot system
 Machinery for setting up a Xen domain which can be resumed over and
 over again, discarding changes made each time.  This can be useful
 for automated testing and other advanced techniques; autopkgtest is
 able to make use of this machinery for its virtualisation needs.
 .
 You will need a working Xen setup to make use of this software.  Your
 network administrator will need to provide support for the testbeds'
 networking requirements.  See the README for documentation.

=== debian/rules ===
#!/usr/bin/make -f
#
# This file is part of autopkgtest
# autopkgtest is a tool for testing Debian binary packages
#
# autopkgtest is Copyright (C) 2006 Canonical Ltd.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# See the file CREDITS for a full list of credits information (often
# installed as /usr/share/doc/autopkgtest/CREDITS).

SHELL=/bin/bash

p=autopkgtest
x=xenlvm
topdir=`pwd`

build build-indep:
	$(MAKE)
	tests/pyflakes
	tests/pep8

build-arch:
binary-arch:

binary binary-indep: checkdir
	dh_testroot
	dh_clean
	dh_installdirs usr

	$(MAKE) install-here prefix=debian/$p/usr
	$(MAKE) -C xen install \
		pkgname=$p-$x \
		prefix=$(topdir)/debian/$p-$x/usr \
		sharedir_lnfrom=/usr/share/$p/$x \
		sharedir=$(topdir)/debian/$p-$x/usr/share/$p/$x \
		etcdir=$(topdir)/debian/$p-$x/etc cfg_suffix=''
	cd debian/$p-$x/etc/userv/services.d && \
		mv -f adt-xenlvm-testbed:dist adt-xenlvm-testbed

	set -e;								\
	  d=debian/autopkgtest/usr/share/doc/autopkgtest/examples/;	\
	  mkdir -p -m755 $$d;						\
	  cp --preserve=timestamps -dR hosts $$d;			\
	  find $$d -name '*~' -o -name '#*#' -exec rm -- '{}' ';';	\
	  for f in $$d/hosts/*; do					\
	    cp debian/host-example-WARNING $$f/WARNING;			\
	    cf=$$f/cfg;							\
	    if test -f $$cf; then					\
	      sed -e 's/^/# /' debian/host-example-WARNING >$$cf.new;	\
	      echo >>$$cf.new;  cat $$cf >>$$cf.new;			\
	      mv -f $$cf.new $$cf;					\
	    fi;								\
	  done

	dh_installinit -p $p-$x --onlyscripts --name=adt$x -- defaults 19
	dh_installchangelogs
	dh_installdocs
	dh_compress
	dh_link
	dh_md5sums
	dh_gencontrol
	dh_fixperms
	dh_installdeb
	dh_builddeb

clean: checkdir
	dh_testroot
	$(MAKE) clean
	rm -rf runner/tmp
	dh_clean

checkdir:
	dh_testdir runner/adt-run

=== tests/testpkg/debian/control ===
Source: testpkg
Maintainer: Autopkgtest team <autopkgtest-devel@lists.alioth.debian.org>
Section: oldlibs
Priority: extra
Standards-Version: 3.9.4
Build-Depends: debhelper (>= 7)

Package: testpkg
Architecture: all
Depends: ${misc:Depends}
Description: test package
 Test package, do not install.

## autopkgtest 2.6~pgdg10.4+1

=== debian/changelog ===
autopkgtest (2.6~pgdg10.4+1) lucid-pgdg; urgency=low

  * Rebuild for lucid-pgdg (jenkins-autopkgtest-source-
    distribution=lucid-12, apt-get revision sid)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Sun, 26 Jan 2014 17:12:31 +0100

autopkgtest (2.6) unstable; urgency=medium

  New features:
  * Add --apt-source option as an alternative for --source, implied if
    argument is a valid package name. It calls "apt-get source" in the testbed
    instead of using a .dsc from the host, which for the common case of
    testing packages in the acual archive avoids having to manually download
    the source and then copying it into the testbed. This simplifies the
    command line for running tests for a package in the archive to
    "adt-run mypkgname --- adt-virt-[...]".
  * Add --setup-commands option to run things like "apt-get update" or adding
    apt sources after opening the testbed.

  Bug fixes:
  * adt-virt-lxc: Stop assuming that containers live in /var/lib/lxc/; ask
    lxc-config about the root path instead.
  * Only reset the test bed after the build stage if builds actually happened.
  * Reset the test bed after running a test group, to avoid an unnecessary
    setup if there is just one test.
  * Don't put an empty "binaries" directory into the output directory.

  New test cases:
  * --timeout handling.

 -- Martin Pitt <mpitt@debian.org>  Thu, 23 Jan 2014 17:19:11 +0100

autopkgtest (2.5.6) unstable; urgency=medium

  * Adjust "su" calls to explicitly specify /bin/sh as shell, as recent
    base-passwd disables them now for system users. (Closes: #734740)

 -- Martin Pitt <mpitt@debian.org>  Thu, 09 Jan 2014 15:21:44 +0100

autopkgtest (2.5.5) unstable; urgency=medium

  * Test that the schroot runner installs packages with --user, and that it
    runs the tests as root with --user if the test has a "needs-root"
    restriction. (Related to #728304)
  * adt-virt-schroot: Add suggested-normal-user capability to the calling user
    (unless that's root), so that tests are run as user by default.
    (Closes: #728304)
  * Add support for virtual "@builddeps@" test dependency, which will be
    replaced with the package's B-D and B-D-I. Document in
    doc/README.package-tests. (Closes: #720458)

 -- Martin Pitt <mpitt@debian.org>  Wed, 25 Dec 2013 21:12:38 +0100

autopkgtest (2.5.4) unstable; urgency=medium

  * Only clean up binary if we built them ourselves. adt-run previously
    removed debs specified with --binary.

 -- Martin Pitt <mpitt@debian.org>  Thu, 19 Dec 2013 16:18:03 +0100

autopkgtest (2.5.3) unstable; urgency=low

  * Drop hosts/ and {onepackage,ubuntu}-config example files; these scripts
    haven't been used nor maintained in years, and we won't need them anytime
    soon. Ubuntu does, and Debian plans to drive autopkgtest from britney
    and/or Jenkins, not from cron.
  * Move adt-testreport-* scripts and manpages into autopkgtest-xenlvm
    package, as they require the xen runner.
  * tests/run-parallel: Immediately stop on pep8/pyflakes errors.
  * Adjust SchrootRunner.test_tree_built_binaries test to also work with
    current apt.
  * Always write UTF-8 to stdout and summary stream, to avoid
    UnicodeEncodeError crash when running in a C locale. (LP: #1259529)
  * tests/pyflakes: Always use pyflakes, not pyflakes3, as the latter doesn't
    get along with non-ASCII strings when running under a non-UTF-8 locale (as
    in sbuild).

 -- Martin Pitt <mpitt@debian.org>  Wed, 11 Dec 2013 08:45:07 +0100

autopkgtest (2.5.2) unstable; urgency=low

  * virt-subproc/adt-virt-lxc: Fix PEP-8 error.
  * Explicitly kill the logging tee processes, for backwards compatibility
    with Python 2.6.
  * Avoid assertNotRegex() in test suite as it isn't yet available in Python
    3.1.
  * Skip dependency version check instead of crashing if python-debian does
    not provide NativeVersion() (for wheezy/lucid).
  * Fix some minor PEP-8 errors.

 -- Martin Pitt <mpitt@debian.org>  Fri, 29 Nov 2013 18:07:09 +0100

autopkgtest (2.5.1) unstable; urgency=low

  * adt-virt-lxc: Drop some dead code.
  * Fix ownership of test tree with --user option.

 -- Martin Pitt <mpitt@debian.org>  Tue, 26 Nov 2013 10:43:30 +0100

autopkgtest (2.5) unstable; urgency=low

  Behaviour changes:
  * Drop --output-dir option. It has never really been useful as it only works
    for paths in the testbed, has a confusing semantics, is redundant with
    --tmp-dir, and currently even crashes adt-run. (Closes: #729790)
  * Rename --tmp-dir option to --output-dir, as its main purpose is really to
    collect test artifacts. Keep --tmp-dir alias for backwards compatibility.
  * Drop --override-control option. It complicates the code too much for its
    very limited utility, and it was not even documented in the manpage.
  * Drop --paths-testbed (and thus also --paths-host) options. There is no
    use case for them.
  * Add short options for common command line options: -B for
    --no-built-binaries, -o for --output-dir, -l for --log-file,
    -u for --user.
  * Clean up uninteresting files from --output-dir directory.
  * Tests which want to create additional artifacts can now put them into the
    $ADT_ARTIFACTS directory. When using the --output-dir option, they will be
    copied into <outputdir>/artifacts/. Document this new feature in
    README.package-tests. (LP: #1137763)

  Packaging changes:
  * Drop obsolete autodebtest Conflicts/Replaces.
  * Update copyright years.
  * Bump Standards-Version to 3.9.5. No changes necessary.
  * CREDITS: Add myself.
  * Makefile: Support $DESTDIR, like automake.
  * Adjust sharedir* defaults in settings.make to what we actually want, and
    drop their overrides in debian/rules
  * Move debian/rules to using dh.
  * Add ./run-from-checkout script to run adt-run from the git checkout or
    source package. Change tests/adt-run to use it.
  * Add tests/run-parallel to run tests for different runners in parallel.

  Bug fixes:


## autopkgtest 2.6~pgdg12.4+1

=== Makefile ===
# This file is part of autopkgtest
# autopkgtest is a tool for testing Debian binary packages
#
# autopkgtest is Copyright (C) 2006 Canonical Ltd.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# See the file CREDITS for a full list of credits information (often
# installed as /usr/share/doc/autopkgtest/CREDITS).

include settings.make

programs =	virt-subproc/adt-virt-chroot \
		virt-subproc/adt-virt-xenlvm \
		virt-subproc/adt-virt-null \
		virt-subproc/adt-virt-schroot \
		virt-subproc/adt-virt-lxc \
		runner/adt-run

pythonfiles =	lib/Autopkgtest.py \
		lib/VirtSubproc.py

all:
	cd xen && $(MAKE)

install-here:
	$(INSTALL_DIRS) -d $(bindir) $(docdir) $(man1dir) \
		$(pythondir)
	set -e; for f in $(programs); do \
		$(INSTALL_PROGRAM) $$f $(bindir); \
		test ! -f $$f.1 || $(INSTALL_DOC) $$f.1 $(man1dir); \
		done
	$(INSTALL_DATA) $(pythonfiles) $(pythondir)
	$(INSTALL_DOC) CREDITS debian/changelog $(docdir)
	$(INSTALL_DOC) doc/README*[!~] $(docdir)

install: install-here
	cd xen && $(MAKE) install

clean:
	rm -f */*.pyc
	cd xen && $(MAKE) clean

=== xen/Makefile ===
# This file is part of autopkgtest
# autopkgtest is a tool for testing Debian binary packages
#
# autopkgtest is Copyright (C) 2006 Canonical Ltd.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# See the file CREDITS for a full list of credits information (often
# installed as /usr/share/doc/autopkgtest/CREDITS).

include ../settings.make

programs =	cleanup setup on-testbed with-testbed purge
binprograms =	adt-testreport-onepackage adt-testreport-runloop adt-testreport-cronjob
shareprograms =	fixups fixups-inside userv-target
sharefiles =	readconfig justconfig

exec_prefix =	adt-xenlvm-

all:		readconfig

install:	all
	$(INSTALL_DIRS) $(bindir) $(docdir) $(man1dir) $(etcconfdir) \
		$(sharedir) $(etcinitddir) $(xenscripts) $(uservsvcdir)
	set -e; for f in $(programs) $(shareprograms); do \
		$(INSTALL_PROGRAM) $$f $(sharedir); \
		done
	set -e; for f in $(programs); do \
		ln -sf $(sharedir_lnfrom)/$$f $(bindir)/$(exec_prefix)$$f; \
		test ! -f $$f.1 || $(INSTALL_DOC) $$f.1 \
			$(man1dir)/$(exec_prefix)$$f; \
		done
	set -e; for f in $(binprograms); do \
		$(INSTALL_PROGRAM) $$f $(bindir); \
		test ! -f $$f.1 || $(INSTALL_DOC) $$f.1 $(man1dir); \
		done
	set -e; for f in $(sharefiles); do \
		$(INSTALL_DATA) $$f $(sharedir); \
		done
	$(INSTALL_DATA) userv-fragment \
		$(uservsvcdir)/adt-xenlvm-testbed:dist
	$(INSTALL_DATA) initscript $(etcinitddir)/adtxenlvm$(cfg_suffix)
	$(INSTALL_PROGRAM) vif-route-adt \
		$(xenscripts)/vif-route-adt$(cfg_suffix)
	$(INSTALL_DOC) README README.userv example-config $(docdir)

readconfig:	sed-readconfig readconfig.in
	sed -f $^ >$@.new && mv -f $@.new $@

sed-readconfig:	README Makefile
	echo '/@@varlist@@/{h' >$@.new
	sed -n 's,^adt_\([_0-9a-z]*\)[ 	].*,s/\\*/\1/p;g,p' <$< >>$@.new
	echo 'd}' >>$@.new && mv -f $@.new $@

clean:
	rm -f readconfig sed-readconfig *~

=== debian/changelog ===
autopkgtest (2.6~pgdg12.4+1) precise-pgdg; urgency=low

  * Rebuild for precise-pgdg (jenkins-autopkgtest-source-
    distribution=precise-12, apt-get revision sid)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Sun, 26 Jan 2014 17:12:34 +0100

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Uploaders: Ian Jackson <ijackson@chiark.greenend.org.uk>, Martin Pitt <mpitt@debian.org>
 Section: devel
 Priority: optional
-Standards-Version: 3.9.4
+Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 8),
  pyflakes,
  pep8
@@ -19,9 +19,7 @@
  apt-utils,
  pbuilder,
  ${misc:Depends}
-Conflicts: autodebtest (<< 0.5.3)
-Replaces: autodebtest (<< 0.5.3)
-Suggests: autopkgtest-xenlvm, curl
+Suggests: autopkgtest-xenlvm
 Description: automatic as-installed testing for Debian packages
  autopkgtest runs tests on binary packages.  The tests are run on the
  package as installed on a testbed system (which may be found via a
@@ -31,13 +29,14 @@
  See adt-run(1) and /usr/share/doc/autopkgtest.
  Most modes of use require apt-ftparchive from the apt-utils package.
  Use of adt-virt-xenlvm requires the autopkgtest-xenlvm package too;
- Use of the pre-cooked adt-testreport-onepackage script requires curl.
 
 Package: autopkgtest-xenlvm
 Architecture: all
 Depends: libadns1-bin, chiark-utils-bin, iproute, dmsetup, ${misc:Depends}
-Recommends: lvm2, debootstrap
+Recommends: lvm2, debootstrap, curl
 Suggests: autopkgtest
+Replaces: autopkgtest (<< 2.5.3~)
+Breaks: autopkgtest (<< 2.5.3~)
 Description: Xen/LVM2 based testbed snapshot system
  Machinery for setting up a Xen domain which can be resumed over and
  over again, discarding changes made each time.  This can be useful
@@ -47,3 +46,5 @@
  You will need a working Xen setup to make use of this software.  Your
  network administrator will need to provide support for the testbeds'
  networking requirements.  See the README for documentation.
+ .
+ Use of the pre-cooked adt-testreport-onepackage script requires curl.

=== debian/rules ===
#!/usr/bin/make -f
#
# This file is part of autopkgtest
# autopkgtest is a tool for testing Debian binary packages
#
# autopkgtest is Copyright (C) 2006 Canonical Ltd.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# See the file CREDITS for a full list of credits information (often
# installed as /usr/share/doc/autopkgtest/CREDITS).

%:
	dh "$@"

override_dh_auto_install:
	$(MAKE) install-here DESTDIR=$(CURDIR)/debian/autopkgtest prefix=/usr
	$(MAKE) -C xen install \
		DESTDIR=$(CURDIR)/debian/autopkgtest-xenlvm \
		prefix=/usr \
		pkgname=autopkgtest-xenlvm \
		cfg_suffix=''

	cd debian/autopkgtest-xenlvm/etc/userv/services.d && \
		mv -f adt-xenlvm-testbed:dist adt-xenlvm-testbed

override_dh_installinit:
	dh_installinit -p autopkgtest-xenlvm --onlyscripts --name=adtxenlvm -- defaults 19

override_dh_auto_test:
	tests/pyflakes
	tests/pep8

# necessary until we move to compat level 9
override_dh_pysupport:
	true

## autopkgtest 2.6~pgdg14.04+1

=== debian/changelog ===
autopkgtest (2.6~pgdg14.04+1) trusty-pgdg; urgency=low

  * Rebuild for trusty-pgdg (jenkins-autopkgtest-source-
    distribution=trusty-12, apt-get revision sid)

 -- apt.postgresql.org autobuilder <myon@debian.org>  Sun, 26 Jan 2014 17:12:37 +0100

## autopkgtest 2.14.1

=== Makefile ===
--- 
+++ 
@@ -27,10 +27,12 @@
 		virt-subproc/adt-virt-null \
 		virt-subproc/adt-virt-schroot \
 		virt-subproc/adt-virt-lxc \
+		virt-subproc/adt-virt-qemu \
+		tools/adt-buildvm-ubuntu-cloud \
+		tools/adt-build-lxc \
 		runner/adt-run
 
-pythonfiles =	lib/Autopkgtest.py \
-		lib/VirtSubproc.py
+pythonfiles =	lib/VirtSubproc.py
 
 all:
 	cd xen && $(MAKE)
@@ -42,6 +44,7 @@
 		$(INSTALL_PROGRAM) $$f $(bindir); \
 		test ! -f $$f.1 || $(INSTALL_DOC) $$f.1 $(man1dir); \
 		done
+	$(INSTALL_PROGRAM) tools/adt-setup-vm $(share)/$(pkgname)
 	$(INSTALL_DATA) $(pythonfiles) $(pythondir)
 	$(INSTALL_DOC) CREDITS debian/changelog $(docdir)
 	$(INSTALL_DOC) doc/README*[!~] $(docdir)

=== xen/Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 include ../settings.make
 
 programs =	cleanup setup on-testbed with-testbed purge
-binprograms =	adt-testreport-onepackage adt-testreport-runloop adt-testreport-cronjob
+binprograms =
 shareprograms =	fixups fixups-inside userv-target
 sharefiles =	readconfig justconfig

=== tests/testpkg/Makefile ===
build:
	/bin/echo -e "#!/bin/sh -e\necho built script OK" > test_built
	chmod 755 test_built

clean:
	rm -f test_built

distclean: clean

install: build
	install -D -m755 test_static $(DESTDIR)/usr/bin/test_static
	install -D -m755 test_built $(DESTDIR)/usr/bin/test_built

=== debian/changelog ===
autopkgtest (2.14.1) unstable; urgency=medium

  * tools/adt-buildvm-ubuntu-cloud: Enable ssh login with passwords.

 -- Martin Pitt <mpitt@debian.org>  Wed, 09 Apr 2014 17:15:29 +0200

autopkgtest (2.14) unstable; urgency=medium

  * lxc: Greatly simplify bind mounting of shared tmp dir using the
    lxc-start -s option.
  * adt-virt-qemu: Forward VM's ssh port 22 to the first free localhost port
    starting from 10022. When finding one, suggest connecting to the VM with
    an appropriate ssh command on --shell.

 -- Martin Pitt <mpitt@debian.org>  Wed, 09 Apr 2014 17:06:44 +0200

autopkgtest (2.13.1) unstable; urgency=medium

  * Fix "--build-tree" typo in error message, and also add the missing
    --unbuilt-tree. (Closes: #743427)
  * lxc: Enable live output in clone mode.

 -- Martin Pitt <mpitt@debian.org>  Tue, 08 Apr 2014 12:18:00 +0200

autopkgtest (2.13) unstable; urgency=medium

  * Split package/version list that got introduced in 2.10: Introduce a new
    output file "testbed-packages" with the packages and versions of the
    pristine testbed, and filter them out of "<testname>-packages", so that
    the latter only contains the packages and versions that are specific to
    that test. This is generally more useful, and how debci does/wants it.

 -- Martin Pitt <mpitt@debian.org>  Tue, 01 Apr 2014 14:43:12 +0100

autopkgtest (2.12) unstable; urgency=medium

  [ Martin Pitt ]
  New features:
  * Add new options -s/--shell-fail for running a shell in the testbed after
    every failed test, and --shell for running a shell in the testbed after
    every test. This should make debugging tests or regressions quite a bit
    simpler. This actually spawns a shell for the null, chroot, schroot, and
    lxc runners, and shows how to login to the VM for qemu (this will
    hopefully be improved in the future, but at least makes debugging possible
    for now).

  Bug fixes:
  * adt-build-lxc: Fix apt proxy setting for ubuntu template; use $HTTP_PROXY,
    not $APT_PROXY.
  * Make PEP-8 failures non-fatal during package build. They often fail in
    backports to old releases, and running them before releasing a new package
    is sufficient.
  * Filter out comment lines from control lines, as python-debian doesn't
    properly do that (Debian #743174). Fixes lintian autopkgtest.
    (LP: #1300031)

  [ Antonio Terceiro ]
  * adt-virt-schroot: Add new option -s/--session-id for specifying a custom
    schroot session id. This is useful for debugging test suites that go crazy
    on ci.debian.net, so you can `schroot --list --all-sessions` and see which
    sessions are still open. (Closes: #742969)

 -- Martin Pitt <mpitt@debian.org>  Mon, 31 Mar 2014 11:45:13 +0200

autopkgtest (2.11) unstable; urgency=medium

  * Add tools/adt-setup-vm: Setup script for vmdebootstrap (and potentially
    others) to start a root shell on tty1, set up networking for eth0, and
    enable deb-src apt sources.
  * adt-virt-qemu.1: Describe how to create a suitable Debian VM with
    vmdebootstrap.
  * doc/README.package-tests: Point out to use "build-needed" with
    consideration.
  * Make installation of packages/dependencies print a warning instead of
    failing immediately when root is not available on the testbed. This allows
    tests to be run with the "null" runner locally as user with some
    restrictions. Check if dpkg-source is available before installing
    dpkg-dev, to avoid the warning in that simple case. (Closes: #742242)
  * Fix ugly error message if a package does not have a debian/tests/
    directory. Properly fail with code 8 and "SKIP no tests in this package".
  * Clean up temporary files in NullRunner tests.

 -- Martin Pitt <mpitt@debian.org>  Fri, 21 Mar 2014 09:36:25 +0100

autopkgtest (2.10) unstable; urgency=medium

  * Record name and version of tested package in log and in
    output-dir/testpkg-version. (first part of LP #1292431)
  * Record installed packages and their versions for each test, in
    <output-dir>/<test>-packages. (second half of LP: #1292431)
  * Drop adt-testreport-*, adt-openbugs-*: These have been marked deprecated
    for a while, haven't been used or maintained in many years, and are
    superseded by jenkins/debci. (Closes: #695974)

 -- Martin Pitt <mpitt@debian.org>  Tue, 18 Mar 2014 16:12:24 +0100

autopkgtest (2.9.2) unstable; urgency=medium

  * VirtSubproc.py, copydown_shareddir(): Fix "src and dest are the same file"
    error when file is already in the shared downtmp.
  * VirtSubproc.py, copydown_shareddir(): Remove already existing target
    directory to avoid copying an updated directory into the old one.
  * adt-run: Show timestamps at the beginning, start of preparation (i. e.
    mostly installing dependencies), and start and end of tests.
    (LP: #1290760)
  * Run NullRunnerNoRoot tests during package build. Add python-debian build
    dependency for that.

 -- Martin Pitt <mpitt@debian.org>  Wed, 12 Mar 2014 08:13:50 +0100

autopkgtest (2.9.1) unstable; urgency=medium

  [ Martin Pitt ]
  * doc/README.package-tests: Clarify syntax of test Depends:, and point to
    the relevant Debian Policy specification.
  * adt-build-lxc: Fall back to assuming /var/lib/lxc/ as container directory
    if lxc-config does not exist. It was introduced in 1.0, but Debian
    unstable still has 0.9. (Closes: #740437)
  * tests: Extend test_artifacts() to multiple tests writing artifacts, also
    with overwriting existing files and writing into subdirs.
  * VirtSubproc: Fix copyup_shareddir() to get along with existing
    directories. (LP: #1288668)
  * settings.make: Switch default prefix to /usr, as our scripts hardcode that
    for finding VirtSubproc.py and this is a native package. (LP: #1287264)

  [ Steve Langasek ]
  * Fix adt-virt-schroot to correctly return root-on-testbed when we're
    running adt-run as root. (Closes: #740868)

 -- Martin Pitt <mpitt@debian.org>  Thu, 06 Mar 2014 13:44:07 +0100



=== debian/control ===
--- 
+++ 
@@ -5,6 +5,7 @@
 Priority: optional
 Standards-Version: 3.9.5
 Build-Depends: debhelper (>= 8),
+ python-debian,
  pyflakes,
  pep8
 Vcs-Git: git://git.debian.org/git/autopkgtest/autopkgtest.git
@@ -19,7 +20,7 @@
  apt-utils,
  pbuilder,
  ${misc:Depends}
-Suggests: autopkgtest-xenlvm
+Suggests: autopkgtest-xenlvm, schroot, lxc, qemu-system, qemu-utils
 Description: automatic as-installed testing for Debian packages
  autopkgtest runs tests on binary packages.  The tests are run on the
  package as installed on a testbed system (which may be found via a
@@ -27,17 +28,18 @@
  supplied in the corresponding Debian source package.
  .
  See adt-run(1) and /usr/share/doc/autopkgtest.
- Most modes of use require apt-ftparchive from the apt-utils package.
- Use of adt-virt-xenlvm requires the autopkgtest-xenlvm package too;
+ Depending on which virtualization server you want to use, you need to
+ install additional packages (schroot, lxc, qemu-system, or
+ autopkgtest-xenlvm).
 
 Package: autopkgtest-xenlvm
 Architecture: all
 Depends: libadns1-bin, chiark-utils-bin, iproute, dmsetup, ${misc:Depends}
-Recommends: lvm2, debootstrap, curl
+Recommends: lvm2, debootstrap
 Suggests: autopkgtest
 Replaces: autopkgtest (<< 2.5.3~)
 Breaks: autopkgtest (<< 2.5.3~)
-Description: Xen/LVM2 based testbed snapshot system
+Description: autopkgtest Xen/LVM2 based testbed snapshot system
  Machinery for setting up a Xen domain which can be resumed over and
  over again, discarding changes made each time.  This can be useful
  for automated testing and other advanced techniques; autopkgtest is
@@ -46,5 +48,3 @@
  You will need a working Xen setup to make use of this software.  Your
  network administrator will need to provide support for the testbeds'
  networking requirements.  See the README for documentation.
- .
- Use of the pre-cooked adt-testreport-onepackage script requires curl.

=== debian/rules ===
--- 
+++ 
@@ -22,26 +22,31 @@
 # See the file CREDITS for a full list of credits information (often
 # installed as /usr/share/doc/autopkgtest/CREDITS).
 
+VERSION=$(shell dpkg-parsechangelog  | sed -n '/^Version:/ {s/^.*: //; p}')
+
 %:
 	dh "$@"
 
 override_dh_auto_install:
-	$(MAKE) install-here DESTDIR=$(CURDIR)/debian/autopkgtest prefix=/usr
+	$(MAKE) install-here DESTDIR=$(CURDIR)/debian/autopkgtest
 	$(MAKE) -C xen install \
 		DESTDIR=$(CURDIR)/debian/autopkgtest-xenlvm \
-		prefix=/usr \
 		pkgname=autopkgtest-xenlvm \
 		cfg_suffix=''
 
 	cd debian/autopkgtest-xenlvm/etc/userv/services.d && \
 		mv -f adt-xenlvm-testbed:dist adt-xenlvm-testbed
 
+	# put our package version into adt-run for logging
+	sed -i 's/@devel@/$(VERSION)/' debian/autopkgtest/usr/bin/adt-run
+
 override_dh_installinit:
 	dh_installinit -p autopkgtest-xenlvm --onlyscripts --name=adtxenlvm -- defaults 19
 
 override_dh_auto_test:
 	tests/pyflakes
-	tests/pep8
+	tests/pep8 || true
+	tests/adt-run NullRunnerNoRoot
 
 # necessary until we move to compat level 9
 override_dh_pysupport:

=== debian/tests/control ===
Tests: adt-run
Depends: autopkgtest, python3
Restrictions: needs-root
Tests-Directory: tests

Tests: pyflakes
Depends: pyflakes
Tests-Directory: tests

=== tests/testpkg/debian/control ===
--- 
+++ 
@@ -8,5 +8,6 @@
 Package: testpkg
 Architecture: all
 Depends: ${misc:Depends}
+Recommends: cpp-doc
 Description: test package
  Test package, do not install.

## autopkgtest 3.6

=== debian/changelog ===
autopkgtest (3.6) unstable; urgency=medium

  [ Antonio Terceiro ]
  * README.package-tests.rst: Make references to the control field consistent.

  [ Martin Pitt ]
  * When parsing .changes files, always register the debs before the dscs and
    stop assuming Files: having this order already. (Closes: #764795)
  * Drop the builtin synthesis of Perl/Ruby tests and use autodep8 instead.
    Update the spec accordingly, and add a Recommends: autodep8.
    (Closes: #763847)
  * adt-build-lxc: Implement LXC cache cleanup for btrfs by removing the image
    snapshots instead of rm -r'ing the cache dir, as the latter will fail.
  * adt-setup-vm: Fix missing hashbang of generated /etc/init.d/autopkgtest.
    (Regression from 3.5.5)

 -- Martin Pitt <mpitt@debian.org>  Thu, 16 Oct 2014 16:36:11 +0200

autopkgtest (3.5.5) unstable; urgency=medium

  * adt-virt-ssh: Be more liberal when parsing the setup script's
    capabilities, accept spaces and commas.
  * adt-virt-ssh: Refactor code so that setup script's "revert" commands can
    update/refresh the ssh config. Often revert translates to close and
    re-open, which changes the IP. Update manpage and ssh-setup/SKELETON
    accordingly.
  * ssh-setup/nova: Make parsing commands work with mawk too, to avoid
    depending on gawk.
  * ssh-setup/nova: Implement a simple revert by a simple teardown/providing a
    new instance. (This might become more efficient in the future with using
    snapshots.)
  * adt-buildvm-ubuntu-cloud: Put vmalloc kernel commandline config into
    separate grub.d/ directory, to avoid subsequent cloud-init invocations
    overwriting it.
  * tools/adt-setup-vm: Add setup steps that adt-buildvm-ubuntu-cloud does, so
    that vmdebootstrap generated VMs are functionally on par with the Ubuntu
    cloud images: Set up serial console, dpkg unsafe-io, install some
    additional packages, remove unnecessary packages, bump vmalloc on i386.
  * adt-buildvm-ubuntu-cloud: Remove most of the setup steps from user-data,
    and call adt-setup-vm instead. This keeps the knowledge of how to set up
    VM testbeds in one single place.

 -- Martin Pitt <mpitt@debian.org>  Thu, 09 Oct 2014 15:20:15 +0200

autopkgtest (3.5.4) unstable; urgency=medium

  adt-run fixes:
  * Make apt-get source calls again show what's being downloaded, but not all
    the other noise around it.
  * Avoid copying down the tests tree into the testbed if it already exists
    there. This is the common case for the first test in unbuilt trees, and
    avoids one round of expensive large copying for the ssh and qemu runners.
  * Fix relative --override-control paths: They should not be relative to the
    source dir but relative to the current dir where adt-run is called.

  ssh-setup/nova fixes:
  * Add -N/--net-id argument for OpenStack deployments which require setting
    an explicit --nic net-id.
  * Stop using nova boot's --file option, it does not work any more (see
    LP#1376176); use --user-data instead. Also set some go-faster apt options.
  * Wait until ssh is available and cloud-init is done.
  * Stop making --keyname mandatory. If not given, use the first one from
    "nova keypair-list".
  * Fix crash if ~/.ssh/known_hosts does not exist.

  ssh-setup/adb fixes:
  * Drop the sudo'ing for unlocking the screen. It stopped working and is not
    necessary, now that we don't have images with adb running as root any
    more.
  * Fix unity8 restart after disabling first-time wizard to work on current
    Ubuntu Touch images.
  * Wait until com.canonical.UnityGreeter becomes available. This is a better
    way to wait for the desktop to be started up, and also reliably unlocks
    the greeter.
  * During revert, don't fail if there are no configured networks.
  * Add -b/--reboot option to reboot the device before running the test.
  * Disable --reset option for now; it is broken as it does not restore the
    password and developer mode. Point towards using --reboot, which should be
    good enough for most cases in r/o mode.

  adt-virt-ssh fixes:
  * Implement reboot.
  * Tests or builds sometimes leak background processes which might still be
    connected to ssh's stdout/err; create and use a wrapper script that kills
    these after the main program (build or test script) finishes, otherwise we
    get eternal hangs as ssh waits until nothing is connected to its tty any
    more.

  Other fixes:
  * adt-buildvm-ubuntu-cloud: Purge more unnecessary packages.

 -- Martin Pitt <mpitt@debian.org>  Wed, 08 Oct 2014 09:22:17 +0200

autopkgtest (3.5.3) unstable; urgency=medium

  * ssh-setup/adb: Use the new "phablet-config network" to save/restore wifi
    connections, which also works with non-root adb.
  * Give adt-run's tee processes some time to catch up between printing
    results and stderr, to avoid scrambled logs. (LP: #1373441)
  * Fix NullRunner.test_timeout_no_output for older Python versions.
  * tests/pyflakes: Skip test if pyflakes3 is not available (for backports).
  * Bump Standards version to 3.9.6 (no changes necessary).
  * NullRunner.test_timeout_no_output: Slightly relax time bound to make
    failures less likely on loaded/slow machines.
  * Install clicks with --allow-unauthenticated to support local developer
    generated packages. (LP: #1372640)

 -- Martin Pitt <mpitt@debian.org>  Sun, 28 Sep 2014 12:16:16 +0200

autopkgtest (3.5.2) unstable; urgency=medium

  [ Martin Pitt ]
  * Make apt-get source and package unpack output a bit less verbose.
  * Avoid "grep: debian/tests/control: No such file or directory" warning for
    packages with implicit test control. (Closes: #762009)
  * Adjust "unpack into temp dir" mode for multi-archified typelib locations
    introduced in gobject-introspection 1.41.4-1.

  [ Niko Tyni ]
  * Test perl packages that include test.pl, not just t/. (Closes: #762013)

 -- Martin Pitt <mpitt@debian.org>  Tue, 23 Sep 2014 09:31:29 +0200

autopkgtest (3.5.1) unstable; urgency=medium



## autopkgtest 3.6git1

=== debian/changelog ===
autopkgtest (3.6git1) utopic; urgency=medium

  Cherry-pick from upstream git:
  * adt-virt-ssh: Rewrite adt-ssh-wrapper to not call the readlink command on
    every single /proc/*/fd/*. This is too slow on devices like Ubuntu Touch,
    where it adds an extra ~ 5 seconds to every command.
  * ssh-setup/adb: Drop --rw and --apt-update options. They stopped working
    when adb switched to running as user, and can be done with
    --setup-commands.

 -- Martin Pitt <martin.pitt@ubuntu.com>  Wed, 22 Oct 2014 10:48:35 -0400
